---
title: HTMLMediaElement.readyState
slug: Web/API/HTMLMediaElement/readyState
tags:
  - API
  - HTML DOM
  - HTMLMediaElement
  - Property
  - Read-only
  - Web
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLMediaElement.readyState</code></strong> property indicates the readiness state of the media.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var readyState = audioOrVideo.readyState;</pre>

<h3 id="Value">Value</h3>

<p>An <code>unsigned short</code>. Possible values are:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>HAVE_NOTHING</code></td>
   <td>0</td>
   <td>No information is available about the media resource.</td>
  </tr>
  <tr>
   <td><code>HAVE_METADATA</code></td>
   <td>1</td>
   <td>Enough of the media resource has been retrieved that the metadata attributes are initialized. Seeking will no longer raise an exception.</td>
  </tr>
  <tr>
   <td><code>HAVE_CURRENT_DATA</code></td>
   <td>2</td>
   <td>Data is available for the current playback position, but not enough to actually play more than one frame.</td>
  </tr>
  <tr>
   <td><code>HAVE_FUTURE_DATA</code></td>
   <td>3</td>
   <td>Data for the current playback position as well as for at least a little bit of time into the future is available (in other words, at least two frames of video, for example).</td>
  </tr>
  <tr>
   <td><code>HAVE_ENOUGH_DATA</code></td>
   <td>4</td>
   <td>Enough data is available—and the download rate is high enough—that the media can be played through to the end without interruption.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>This example will listen for audio data to be loaded for the element `example`. It will then check if at least the current playback position has been loaded. If it has, the audio will play.</p>

<pre class="brush: html">&lt;audio id="example" preload="auto"&gt;
 &lt;source src="sound.ogg" type="audio/ogg" /&gt;
&lt;/audio&gt;

</pre>

<pre class="brush: js">var obj = document.getElementById('example');

obj.addEventListener('loadeddata', function() {

  if(obj.readyState &gt;= 2) {
    obj.play();
  }

});
</pre>


<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#dom-media-readystate", "HTMLMediaElement.readyState")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', "embedded-content-0.html#htmlmediaelement", "HTMLMediaElement.readyState")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.readyState")}}</p>

<h2 id="See_Also">See also</h2>

<ul>
 <li>The interface defining it, {{domxref("HTMLMediaElement")}}.</li>
</ul>
